package com.persagy.apm.alarmservice.group.calculatemethod.model;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import com.persagy.apm.common.model.entity.AuditableEntity;
import java.io.Serializable;

/**
 * 计算方式(CalculateMethod)实体类
 * @author lixing
 * @version V1.0 2021-09-08 22:43:58
 */
@EqualsAndHashCode(callSuper = true)
@Data
@ApiModel(description = "计算方式")
public class CalculateMethod extends AuditableEntity<CalculateMethod> implements Serializable {
    private static final long serialVersionUID = -61587285284741274L;

    @ApiModelProperty("计算方式名称")
    private String name;
    
    @ApiModelProperty("公式")
    private String formula;
    
    @ApiModelProperty("监测指标id")
    private String monitorIndicatorId;
    
    @ApiModelProperty("是否是指标默认计算方式")
    private String isDefault;

    @ApiModelProperty("报警系统编码")
    private String category;

    public static String PROP_NAME = "name";
    public static String PROP_FORMULA = "formula";
    public static String PROP_MONITOR_INDICATOR_ID = "monitor_indicator_id";
    public static String PROP_IS_DEFAULT = "is_default";
    public static String PROP_CATEGORY = "category";

}
