package com.persagy.apm.alarmservice.group.management.controller;

import com.persagy.apm.alarmservice.group.management.model.group.vo.GroupTreeVO;
import com.persagy.apm.alarmservice.group.management.service.GroupManagementService;
import com.persagy.apm.alarmservice.group.objgroup.model.dto.QueryObjGroupDTO;
import com.persagy.apm.common.response.CommonResult;
import com.persagy.apm.common.utils.ResultHelper;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.validation.Valid;
import java.util.List;


/**
 * @author 易涛
 * @version 1.0
 * @date 2021/9/7 18:09
 */
@Api(tags = "分组管理")
@RestController
@RequestMapping("group-management")
public class GroupManagementController {

    @Autowired
    private GroupManagementService managementService;

    @ApiOperation(value = "获取分组树")
    @PostMapping("/eq_groups/tree")
    public CommonResult<List<GroupTreeVO>> queryGroupTree(@Valid @RequestBody QueryObjGroupDTO queryObjGroupDTO){
        return ResultHelper.single(managementService.getGroupTree(queryObjGroupDTO));
    }
}
