package com.persagy.apm.alarmservice.group.monitorindicator.model;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.handlers.FastjsonTypeHandler;
import com.persagy.apm.common.model.vo.EnumVO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import com.persagy.apm.common.model.entity.AuditableEntity;
import java.io.Serializable;
import java.util.List;

/**
 * 监测指标(MonitorIndicator)实体类
 * @author lixing
 * @version V1.0 2021-09-08 22:44:37
 */
@EqualsAndHashCode(callSuper = true)
@Data
@ApiModel(description = "监测指标")
@TableName(autoResultMap = true)
public class MonitorIndicator extends AuditableEntity<MonitorIndicator> implements Serializable {
    private static final long serialVersionUID = -53576386032508621L;

    @ApiModelProperty("指标名称")
    private String name;
    
    @ApiModelProperty("设备类")
    private String classCode;

    @ApiModelProperty("单位")
    private String unit;

    @ApiModelProperty("可选值字典")
    @TableField(typeHandler = FastjsonTypeHandler.class)
    private EnumVO[] dic;

    @ApiModelProperty("报警系统编码")
    private String category;

    public static String PROP_NAME = "name";
    public static String PROP_CLASS_CODE = "class_code";
    public static String PROP_CLASS_UNIT = "unit";
    public static String PROP_CATEGORY = "category";

}
