package com.persagy.apm.alarmservice.project.alarmrule.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.persagy.apm.alarmservice.group.alarmrule.model.GroupAlarmRule;
import com.persagy.apm.alarmservice.group.alarmrule.model.dto.AddGroupAlarmRuleDTO;
import com.persagy.apm.alarmservice.project.alarmrule.model.ProjectAlarmRule;
import com.persagy.apm.alarmservice.project.alarmrule.model.dto.*;
import com.persagy.apm.alarmservice.project.alarmrule.model.vo.ProjectAlarmRuleListItemVO;
import com.persagy.apm.alarmservice.project.alarmruleobjrel.model.dto.AddProjectAlarmRuleObjRelDTO;
import com.persagy.apm.alarmservice.project.alarmruleobjrel.model.dto.QueryRuleObjRelDTO;
import com.persagy.apm.alarmservice.project.alarmruleobjrel.model.vo.ProjectVO;
import com.persagy.apm.energyalarmstarter.alarmdata.model.dto.alarmconfig.AddAlarmConfigDTO;

import java.util.List;

/**
 * 项目报警规则(ProjectAlarmRule) service接口
 *
 * @author lixing
 * @version V1.0 2021-09-08 22:46:16
 */
public interface IProjectAlarmRuleService  {

    public List<ProjectAlarmRuleListItemVO> pageBySubList(List<ProjectAlarmRuleListItemVO> list, int pagesize, int currentPage) ;

    /**
    * 创建项目报警规则
    *
    * @param addProjectAlarmRuleDTO addDTO
    * @return 项目报警规则主键
    * @author lixing
    * @version V1.0 2021-09-08 22:46:16
    */
    public String createProjectAlarmRule(AddProjectAlarmRuleDTO addProjectAlarmRuleDTO) throws Exception;
    
    /**
    * 项目报警规则详情
    *
    * @param id 主键
    * @return 项目报警规则do对象
    * @author lixing
    * @version V1.0 2021-09-08 22:46:16
    */
    public ProjectAlarmRule queryProjectAlarmRuleDetail(String id);
    
    /**
    * 更新项目报警规则
    *
    * @param updateProjectAlarmRuleDTO updateDTO
    * @author lixing
    * @version V1.0 2021-09-08 22:46:16
    */
    public void updateProjectAlarmRule(UpdateProjectAlarmRuleDTO updateProjectAlarmRuleDTO) throws Exception;
    
    /**
    * 删除项目报警规则
    *
    * @param ruleId 报警规则id
    * @author lixing
    * @version V1.0 2021-09-08 22:46:16
    */
    public void deleteProjectAlarmRule(String ruleId) throws Exception;
    
    /**
    * 查询项目报警规则
    *
    * @param queryProjectAlarmRuleDTO queryDTO
    * @return List<ProjectAlarmRule>
    * @author lixing
    * @version V1.0 2021-09-08 22:46:16
    */
    public List<ProjectAlarmRule> queryProjectAlarmRuleList(QueryProjectAlarmRuleDTO queryProjectAlarmRuleDTO);
    
    /**
    * 分页查询项目报警规则
    * 
    * @param pageQueryProjectAlarmRuleDTO pageQueryDTO
    * @return IPage<ProjectAlarmRule>
    * @author lixing
    * @version V1.0 2021-09-08 22:46:16
    */
    public IPage<ProjectAlarmRule> pageQueryProjectAlarmRule(PageQueryProjectAlarmRuleDTO pageQueryProjectAlarmRuleDTO);

    void addProjectAlarmRules(AddGroupAlarmRuleDTO addGroupAlarmRuleDTO);

    /**
     * 获取项目
     */
    List<ProjectVO> getProject();

    List<String> queryAlarmRule(QueryRuleObjRelDTO queryRuleObjRelDTO);

    void insertProject(String substring);

    // 勿删后续可能启用 lixing
//    /**
//     * 发送批量创建报警定义消息
//     *
//     * @param alarmConfigs 需要创建的报警定义
//     * @param projectId 项目id
//     * @author lixing
//     * @version V1.0 2021/10/11 8:38 下午
//     */
//    void sendBatchCreateAlarmConfigMsg(List<AddAlarmConfigDTO> alarmConfigs, String projectId);

    void deleteBatchByGroupRule(GroupAlarmRule groupAlarmRule) throws Exception;

    /**
     * TODO 压测  新增项目规则
     * @param addGroupAlarmRuleDTO
     */
    void addProjectAlarmRulesPM(AddGroupAlarmRuleDTO addGroupAlarmRuleDTO);

}
