package com.persagy.apm.dmpalarm.client;

import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

import com.fasterxml.jackson.databind.node.ObjectNode;
import com.persagy.apm.dmpalarm.criteria.JsonCriteria;
import com.persagy.apm.dmpalarm.web.PagedResponse;

/**
 * @description: 对接物理世界接口
 * @author: lixing
 * @company: Persagy Technology Co.,Ltd
 * @since: 2020/10/20 5:04 下午
 * @version: V1.0
 **/
@FeignClient(name = "dmp-rwd", fallbackFactory = PhysicalWorldFallBackFactory.class)
public interface PhysicalWorldClient {

    @PostMapping("rwd/instance/object/query")
    public PagedResponse<ObjectNode> queryObj(
            @RequestParam("projectId") String projectId,
            @RequestParam("groupCode") String groupCode,
            @RequestBody JsonCriteria criteria);
}
