package com.persagy.apm.dmpalarm.config;

import java.util.Collections;
import java.util.HashMap;

import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import com.baomidou.mybatisplus.extension.parsers.DynamicTableNameParser;
import com.baomidou.mybatisplus.extension.parsers.ITableNameHandler;
import com.baomidou.mybatisplus.extension.plugins.PaginationInterceptor;
import com.persagy.apm.dmpalarm.utils.UtilsTools;
import com.persagy.common.utils.StringUtil;

/**
 * 动态表名
 */
@Configuration
public class MybatisPlusTableNameConfig {

	@SuppressWarnings("serial")
	@Bean
	public PaginationInterceptor paginationInterceptor() {
		PaginationInterceptor paginationInterceptor = new PaginationInterceptor();
		DynamicTableNameParser dynamicTableNameParser = new DynamicTableNameParser();
		dynamicTableNameParser.setTableNameHandlerMap(new HashMap<String, ITableNameHandler>(2) {
			{
				put("alarm_record", (metaObject, sql, tableName) -> {
					System.err.println("tableName " + tableName);
					System.err.println("sql " + sql);
					System.err.println("metaObject " + metaObject);
					String myTableName = UtilsTools.myTableNameSuffix.get();
					if (StringUtil.isNotBlank(myTableName)) {
						tableName = tableName + "_" + myTableName;
					}
					return tableName;
				});
			}
		});
		paginationInterceptor.setSqlParserList(Collections.singletonList(dynamicTableNameParser));
		return paginationInterceptor;
	}

}