package com.persagy.apm.dmpalarm.controller;

import javax.annotation.Resource;

import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.persagy.apm.dmpalarm.criteria.JsonCriteria;
import com.persagy.apm.dmpalarm.jms.MessageProcesser;
import com.persagy.apm.dmpalarm.model.AlarmComment;
import com.persagy.apm.dmpalarm.model.DmpMessage;
import com.persagy.apm.dmpalarm.service.IAlarmCommentService;
import com.persagy.apm.dmpalarm.web.MapResponse;
import com.persagy.apm.dmpalarm.web.PagedResponse;

import io.swagger.annotations.Api;

/**
 * 报警批注控制层
 *
 * @author lixing
 * @version V1.0 2021-12-09 10:43:56
 */
@Api(tags = "报警批注")
@Validated
@RestController("dmpAlarmComment")
@RequestMapping("/alarm/comment")
public class AlarmCommentController {
    @Resource(name = "dmpAlarmCommentService")
    private IAlarmCommentService alarmCommentService;
    @Resource
    private MessageProcesser messageProcesser;

    @PostMapping("/query")
    public PagedResponse<AlarmComment> query(@RequestBody JsonCriteria criteria) {
        return alarmCommentService.query(criteria);
    }

    @PostMapping("/create")
    public MapResponse create(@RequestBody AlarmComment param) {
        return alarmCommentService.create(param);
    }

    @PostMapping("/delete")
    public MapResponse delete(@RequestBody AlarmComment param) {
        return alarmCommentService.delete(param);
    }

    @PostMapping("/sendMessage")
    public MapResponse update(@RequestBody AlarmComment param) {
        for (int i = 0; i < 2000; i++) {
            DmpMessage dmpMessage = new DmpMessage();
            dmpMessage.setMid(String.valueOf(i));
            dmpMessage.setType("sleep");
            messageProcesser.convertAndSend(dmpMessage);
        }
        return new MapResponse();
    }

}

