/**
 * 
 */
package com.persagy.apm.dmpalarm.controller;

import javax.annotation.Resource;

import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.persagy.apm.dmpalarm.criteria.JsonCriteria;
import com.persagy.apm.dmpalarm.model.AlarmEventType;
import com.persagy.apm.dmpalarm.service.IAlarmEventTypeService;
import com.persagy.apm.dmpalarm.web.MapResponse;
import com.persagy.apm.dmpalarm.web.PagedResponse;

import io.swagger.annotations.Api;

/**
 * @author gaoyu
 *
 */
@Api(tags = "报警原因事件类型")
@Validated
@RestController("dmpAlarmEvent")
@RequestMapping("/alarm/event")
public class AlarmEventTypeController {
	
    @Resource(name="dmpAlarmEventTypeService")
    private IAlarmEventTypeService alarmEventTypeService;

    @PostMapping("/query")
    public PagedResponse<AlarmEventType> query(@RequestBody JsonCriteria criteria) {
        return alarmEventTypeService.query(criteria);
    }

    @PostMapping("/create")
    public MapResponse create(@RequestBody AlarmEventType param){
        return alarmEventTypeService.create(param);
    }

    @PostMapping("/update")
    public MapResponse update(@RequestBody AlarmEventType param){
        return alarmEventTypeService.update(param);
    }
    @PostMapping("/delete")
    public MapResponse delete(@RequestBody AlarmEventType param){
        return alarmEventTypeService.delete(param);
    }
}
