package com.persagy.apm.dmpalarm.controller;

import javax.annotation.Resource;

import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.persagy.apm.dmpalarm.criteria.JsonCriteria;
import com.persagy.apm.dmpalarm.model.AlarmRecord;
import com.persagy.apm.dmpalarm.service.IAlarmRecordService;
import com.persagy.apm.dmpalarm.web.MapResponse;
import com.persagy.apm.dmpalarm.web.PagedResponse;

import io.swagger.annotations.Api;

/**
 * 报警记录控制层
 * 
 * @author lixing
 * @version V1.0 2021-12-09 10:43:56
 */
@Api(tags = "报警记录")
@Validated
@RestController("dmpAlarmRecord")
@RequestMapping("/alarm/record")
public class AlarmRecordController {

	@Resource(name="dmpAlarmRecordService")
	private IAlarmRecordService alarmRecordService;

	@PostMapping("/query")
	public PagedResponse<AlarmRecord> query(@RequestBody JsonCriteria criteria) {
		return alarmRecordService.query(criteria);
	}

	@PostMapping("/create")
	public MapResponse create(@RequestBody AlarmRecord alarmRecord) {
		return alarmRecordService.create(alarmRecord);
	}

	@PostMapping("/update")
	public MapResponse update(@RequestBody AlarmRecord alarmRecord) {
		return alarmRecordService.update(alarmRecord);
	}

	@PostMapping("/batch_update")
	public MapResponse batchUpdate(@RequestBody AlarmRecord alarmRecord) {
		return alarmRecordService.batchUpdate(alarmRecord);
	}

}
