package com.persagy.apm.dmpalarm.controller;

import javax.annotation.Resource;

import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.persagy.apm.dmpalarm.criteria.JsonCriteria;
import com.persagy.apm.dmpalarm.model.AlarmTarget;
import com.persagy.apm.dmpalarm.service.IAlarmTargetService;
import com.persagy.apm.dmpalarm.web.MapResponse;
import com.persagy.apm.dmpalarm.web.PagedResponse;

import io.swagger.annotations.Api;

/**
 * 报警匹配条件控制层
 *
 * @author lixing
 * @version V1.0 2021-12-09 10:43:56
 */
@Api(tags = "报警匹配条件")
@Validated
@RestController("dmpAlarmTarget")
@RequestMapping("/alarm/target")
public class AlarmTargetController {
    @Resource
    private IAlarmTargetService alarmTargetService;

    @PostMapping("/query")
    public PagedResponse<AlarmTarget> query(@RequestBody JsonCriteria criteria) {
        return alarmTargetService.query(criteria);
    }
    @PostMapping("/create")
    public MapResponse create(@RequestBody AlarmTarget param) {
        return alarmTargetService.create(param);
    }

    @PostMapping("/update")
    public MapResponse update(@RequestBody AlarmTarget param) {
        return alarmTargetService.update(param);
    }

    @PostMapping("/delete")
    public MapResponse delete(@RequestBody AlarmTarget param) {
        return alarmTargetService.delete(param);
    }
}

