package com.persagy.apm.dmpalarm.jms;

import java.util.concurrent.ExecutorService;
import java.util.concurrent.LinkedBlockingQueue;
import java.util.concurrent.ThreadPoolExecutor;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.persagy.apm.dmpalarm.model.DmpMessage;

import cn.hutool.core.thread.ExecutorBuilder;

/**
 * 消费消息线程池
 *
 * @author lixing
 * @version V1.0 2021/5/12 2:53 下午
 **/
@Component
public class ConsumeMessageThreadPool {
    private final ExecutorService es;

    @Autowired
    private MessageProcesser messageProcesser;

    public ConsumeMessageThreadPool() {
        es = ExecutorBuilder.create()
                .setCorePoolSize(5)
                .setMaxPoolSize(10)
                .setWorkQueue(new LinkedBlockingQueue<>(10))
                .setHandler(new ThreadPoolExecutor.CallerRunsPolicy())
                .build();
    }

    public void consumeMessage(DmpMessage message) throws Exception {
        es.execute(() -> {
            messageProcesser.listen(message);
        });
    }
}
