package com.persagy.apm.dmpalarm.model;

import java.io.Serializable;
import java.util.Date;

import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * 报警批注(AlarmComment)实体类
 * @author lixing
 * @version V1.0 2021-12-09 10:44:53
 */
@Data
@ApiModel(description = "报警批注")
@TableName(autoResultMap = true)
public class AlarmComment implements Serializable {
    private static final long serialVersionUID = -25604656657950729L;

    private String id;

    @ApiModelProperty("报警记录id")
    private String recordId;
    
    @ApiModelProperty("批注内容")
    private String content;
    
    @ApiModelProperty("创建人")
    private String createUser;
    
    @ApiModelProperty("项目id")
    private String projectId;
    
    @ApiModelProperty("集团编码")
    private String groupCode;
    
    @ApiModelProperty("创建时间")
    private Date createTime;
    
    @ApiModelProperty("更新时间")
    private Date updateTime;
    
    @ApiModelProperty("更新人")
    private String updateUser;
    private Integer valid;
    @ApiModelProperty("alarm_event 外键")
    private String eventTypeId;
    
    public static String PROP_RECORD_ID = "record_id";
    public static String PROP_CONTENT = "content";
    public static String PROP_CREATE_USER = "create_user";
    public static String PROP_PROJECT_ID = "project_id";
    public static String PROP_GROUP_CODE = "group_code";
    public static String PROP_CREATE_TIME = "create_time";
    public static String PROP_UPDATE_TIME = "update_time";
    public static String PROP_UPDATE_USER = "update_user";
    public static String PROP_EVENT_TYPE_ID = "event_type_id";
}
