package com.persagy.apm.dmpalarm.model;

import java.io.Serializable;
import java.util.Date;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.handlers.FastjsonTypeHandler;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * 报警条目(AlarmItem)实体类
 * 
 * @author lixing
 * @version V1.0 2021-12-09 10:44:49
 */
@Data
@ApiModel(description = "报警条目")
@TableName(autoResultMap = true)
public class AlarmItem implements Serializable {
	private static final long serialVersionUID = 683658832546296259L;
	
	private String id;
	@ApiModelProperty("报警条目编码")
	private String code;

	@ApiModelProperty("报警条目名称")
	private String name;

	@ApiModelProperty("报警分类")
	private String category;

	@ApiModelProperty("严重程度")
	private String level;

	@ApiModelProperty("备注")
	private String remark;

	@ApiModelProperty("触发条件")
	@TableField(value = "`condition`", typeHandler = FastjsonTypeHandler.class)
	private JSONObject condition;

	@ApiModelProperty("处理算法")
	private String dealFun;

	@ApiModelProperty("创建用户")
	private String createUser;

	@ApiModelProperty("项目id，0代表通用")
	private String projectId;

	@ApiModelProperty("集团编码，0代表通用")
	private String groupCode;

	@ApiModelProperty("创建时间")
	private Date createTime;

	@ApiModelProperty("更新用户")
	private String updateUser;

	@ApiModelProperty("更新时间")
	private Date updateTime;

	@ApiModelProperty("应用id")
	@TableField(value="`app_id`")
	private String appId;

	public static String PROP_CODE = "code";
	public static String PROP_NAME = "name";
	public static String PROP_CATEGORY = "category";
	public static String PROP_LEVEL = "level";
	public static String PROP_REMARK = "remark";
	public static String PROP_CONDITION = "condition";
	public static String PROP_DEAL_FUN = "deal_fun";
	public static String PROP_CREATE_USER = "create_user";
	public static String PROP_PROJECT_ID = "project_id";
	public static String PROP_GROUP_CODE = "group_code";
	public static String PROP_CREATE_TIME = "create_time";
	public static String PROP_UPDATE_USER = "update_user";
	public static String PROP_UPDATE_TIME = "update_time";
	public static String PROP_APP_ID = "app_id";

}
