package com.persagy.apm.dmpalarm.model;

import java.io.Serializable;
import java.util.Date;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.annotation.TableField;

import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.handlers.FastjsonTypeHandler;

import io.swagger.annotations.ApiModel;
import lombok.Data;

/**
 * 报警日志(AlarmLog)实体类
 * 
 * @author lixing
 * @version V1.0 2021-12-09 10:44:53
 */
@Data
@ApiModel(description = "报警日志")
@TableName(autoResultMap = true)
public class AlarmLog implements Serializable {
	private static final long serialVersionUID = 618980609835731542L;

	private String id;
	private String recordId;
	@TableField(value = "`type`")
	private String type;
	private Integer nature;
	@TableField(value = "`before`")
	private Integer before;
	@TableField(value = "`after`")
	private Integer after;
	@TableField(typeHandler = FastjsonTypeHandler.class)
	private JSONObject remark;
	private Date createTime;
	private String projectId;
	private String groupCode;
	private String createUser;

	public static String PROP_RECORD_ID = "record_id";
	public static String PROP_TYPE = "type";
	public static String PROP_NATURE = "nature";
	public static String PROP_BEFORE = "before";
	public static String PROP_AFTER = "after";
	public static String PROP_REMARK = "remark";
	public static String PROP_PROJECT_ID = "project_id";
	public static String PROP_GROUP_CODE = "group_code";
	public static String PROP_CREATE_TIME = "create_time";
	public static String PROP_UPDATE_TIME = "update_time";
	public static String PROP_CREATE_USER = "create_user";

}
