package com.persagy.apm.dmpalarm.model;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.annotation.JSONField;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.handlers.FastjsonTypeHandler;

import lombok.Data;

@Data
@TableName(autoResultMap = true)
public class AlarmRecord implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private String id;
	private String itemCode;
	private String projectId;
	private String objId;
	private String objName;
	private String classCode;
	private String level;
	private String remark;
	private String name;
	private String category;
	private Integer concern;
	private Integer state;
	private Integer alarmState;
	private Date effectStartTime;
	private Date effectEndTime;
	/**
	 * 报警性质
	 */
	private Integer nature;
	/**
	 * 处理方式
	 */
	private Integer treatMode;
	/**
	 * 处理状态
	 */
	private Integer treatState;
	private String createUser;
	@TableField(value = "`condition`", typeHandler = FastjsonTypeHandler.class)
	private JSONObject condition;
	@TableField(typeHandler = FastjsonTypeHandler.class)
	@JSONField(jsonDirect = true)
	private JSONObject triggerInfo;
	private Date triggerTime;
	@TableField(typeHandler = FastjsonTypeHandler.class)
	private JSONObject endInfo;
	private Date endTime;
	private Date createTime;
	private String updateUser;
	private Date updateTime;
	private Integer valid;
	private String groupCode;
	private String orderId;
	private String orderState;
	@TableField(typeHandler = FastjsonTypeHandler.class)
	private JSONObject supplement;

	public void setSupplement(JSONObject supplement) {
		this.supplement = supplement;
		if (null != supplement && !supplement.isEmpty()) {
			this.setObjName(supplement.getString("alarm_obj_name"));
		}
	}

	/**
	 * 忽略报警时间
	 */
	@TableField(exist = false)
	private Date ignoreTime;
	/**
	 * 报警处理完成时间
	 */

	@TableField(exist = false)
	private Date treatEndTime;
	private String targetId;
	@TableField(exist = false)
	private List<AlarmRecord> alarmRecordModels;
	public static String PROP_ITEM_CODE = "item_code";
	public static String PROP_PROJECT_ID = "project_id";
	public static String PROP_OBJ_ID = "obj_id";
	public static String PROP_CLASS_CODE = "class_code";
	public static String PROP_LEVEL = "level";
	public static String PROP_REMARK = "remark";
	public static String PROP_CREATE_USER = "create_user";
	public static String PROP_CREATE_TIME = "create_time";
	public static String PROP_UPDATE_USER = "update_user";
	public static String PROP_UPDATE_TIME = "update_time";
	public static String PROP_NAME = "name";
	public static String PROP_CATEGORY = "category";
	public static String PROP_CONCERN = "concern";
	public static String PROP_STATE = "state";
	public static String PROP_EFFECT_START_TIME = "effect_start_time";
	public static String PROP_EFFECT_END_TIME = "effect_end_time";
	public static String PROP_NATURE = "nature";
	public static String PROP_TREAT_MODE = "treat_mode";
	public static String PROP_TREAT_STATE = "treat_state";
	public static String PROP_ALARM_STATE = "alarm_state";
	public static String PROP_GROUP_CODE = "group_code";
	public static String PROP_CONDITION = "condition";
	public static String PROP_TRIGGER_INFO = "trigger_info";
	public static String PROP_END_INFO = "end_info";
	public static String PROP_TRIGGER_TIME = "trigger_time";
	public static String PROP_END_TIME = "end_time";
	public static String PROP_ORDER_ID = "order_id";
	public static String PROP_ORDER_STATE = "order_state";
	public static String PROP_SUPPLEMENT = "supplement";
	public static String PROP_TARGET_ID = "target_id";

}
