package com.persagy.apm.dmpalarm.model;

import java.io.Serializable;
import java.util.Date;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.handlers.FastjsonTypeHandler;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * 报警匹配条件(AlarmTarget)实体类
 * @author lixing
 * @version V1.0 2021-12-09 10:44:53
 */
@Data
@ApiModel(description = "报警匹配条件")
@TableName(autoResultMap = true)
public class AlarmTarget implements Serializable {
    private static final long serialVersionUID = 584249238241159229L;
    @ApiModelProperty("主键")
    private String id;

    @ApiModelProperty("报警条目id")
    private String itemCode;
    
    @ApiModelProperty("对象类型")
    private String classCode;
    
    @ApiModelProperty("触发条件")
	@TableField(value = "`condition`", typeHandler = FastjsonTypeHandler.class)
    private JSONObject condition;
    
    @ApiModelProperty("报警等级")
    private String level;
    
    @ApiModelProperty("是否重点关注")
    private Integer concern=0;
    
    @ApiModelProperty("屏蔽状态（0：不屏蔽，1：屏蔽）")
    private Integer open=1;
    
    @ApiModelProperty("创建用户")
    private String createUser;
    
    @ApiModelProperty("创建时间")
    private Date createTime;
    
    @ApiModelProperty("更新用户")
    private String updateUser;
    
    @ApiModelProperty("更新时间")
    private Date updateTime;
    
    @ApiModelProperty("项目id")
    private String projectId;
    
    @ApiModelProperty("集团编码")
    private String groupCode;

    private Integer valid=1;
    

    public static String PROP_ITEM_CODE = "item_code";
    public static String PROP_CLASS_CODE = "class_code";
    public static String PROP_CONDITION = "condition";
    public static String PROP_LEVEL = "level";
    public static String PROP_CONCERN = "concern";
    public static String PROP_OPEN = "open";
    public static String PROP_CREATE_USER = "create_user";
    public static String PROP_CREATE_TIME = "create_time";
    public static String PROP_UPDATE_USER = "update_user";
    public static String PROP_UPDATE_TIME = "update_time";
    public static String PROP_PROJECT_ID = "project_id";
    public static String PROP_GROUP_CODE = "group_code";

}
