package com.persagy.apm.dmpalarm.service;

import com.persagy.apm.dmpalarm.criteria.JsonCriteria;
import com.persagy.apm.dmpalarm.model.AlarmConfig;
import com.persagy.apm.dmpalarm.web.MapResponse;
import com.persagy.apm.dmpalarm.web.PagedResponse;

import java.util.List;

/**
 * 报警定义(AlarmConfig) service接口
 *
 * @author lixing
 * @version V1.0 2021-12-09 10:44:19
 */
public interface IAlarmConfigService {


    public PagedResponse<AlarmConfig> query(JsonCriteria criteria);

    public MapResponse create(AlarmConfig alarmConfig);

    public MapResponse batchCreate(List<AlarmConfig> alarmConfigList);

    public MapResponse batchUpdate(List<AlarmConfig> alarmConfigList);

    public MapResponse batchDelete(AlarmConfig alarmConfig);

    public MapResponse update(AlarmConfig param);

    public  MapResponse delete(AlarmConfig alarmConfig);

    public  MapResponse init(AlarmConfig alarmConfig);

    MapResponse batchDeleteWhenTargetDelete(String targetId, String projectId, String groupCode);

    MapResponse batchUpdateWhenTargetUpdate(String targetId, String projectId, String groupCode, String appId);

    MapResponse batchUpdateWhenItemUpdate(String itemCode, String projectId, String groupCode);

    MapResponse deleteOnRemoveObj(String targetId, String projectId);
}
