package com.persagy.apm.dmpalarm.service;

import com.persagy.apm.dmpalarm.criteria.JsonCriteria;
import com.persagy.apm.dmpalarm.model.AlarmItem;
import com.persagy.apm.dmpalarm.web.MapResponse;
import com.persagy.apm.dmpalarm.web.PagedResponse;

import java.util.List;
import java.util.Map;

/**
 * 报警条目(AlarmItem) service接口
 *
 * @author lixing
 * @version V1.0 2021-12-09 10:44:19
 */
public interface IAlarmItemService  {

   public Map<String, AlarmItem> getItemCodeModelMap(List<String> itemCodeList);

   public AlarmItem getAlarmItemByItemCode(String itemCode, String projectId, String groupCode, String appId);

   public PagedResponse<AlarmItem> query(JsonCriteria criteria);

   public MapResponse create(AlarmItem param);

   public  MapResponse update(AlarmItem param);

   public List<AlarmItem> queryList(JsonCriteria criteria);
}
