package com.persagy.apm.dmpalarm.service;

import java.util.List;
import java.util.Map;

import com.alibaba.fastjson.JSONObject;
import com.persagy.apm.dmpalarm.criteria.JsonCriteria;
import com.persagy.apm.dmpalarm.model.AlarmItem;
import com.persagy.apm.dmpalarm.model.AlarmTarget;
import com.persagy.apm.dmpalarm.web.MapResponse;
import com.persagy.apm.dmpalarm.web.PagedResponse;

/**
 * 报警匹配条件(AlarmTarget) service接口
 *
 * @author lixing
 * @version V1.0 2021-12-09 10:44:19
 */
public interface IAlarmTargetService  {


    public PagedResponse<AlarmTarget> query(JsonCriteria criteria);

    public MapResponse create(AlarmTarget param);

    public MapResponse update(AlarmTarget param);

    public MapResponse delete(AlarmTarget param);

    public JSONObject getCondition(AlarmTarget targetModel, AlarmItem itemModel);

    public List<AlarmTarget> getAlarmTargetsByItemCode(String itemCode, String projectId);

    public AlarmTarget get(String targetId);

    public Map<String, AlarmItem> getItemCodeModelMapByModelList(List<AlarmTarget> targets);
}
