package com.persagy.apm.dmpalarm.service;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.persagy.apm.dmpalarm.model.ShardingEntity;
import com.persagy.apm.dmpalarm.web.PagedResponse;
/**
 * 分表IShardingService
 * @author GaoYu
 *
 */
public interface IShardingService {
	/**
	 * 得到分表之后的表的相关信息 默认排序分表的字段倒序DESC
	 * @param <T>
	 * 
	 * @param tableNamePrefix
	 * @param startTime
	 * @param endTime
	 * @return
	 */
	<T> List<ShardingEntity> getTableNameShardingList(Class<T> cls, Date startTime, Date endTime);

	/**
	 * 查询分表后的总数
	 * @param <T>
	 * 
	 * @param tableNamePrefix 分表名称前缀
	 * @param queryWrapper    查询条件
	 * @return
	 */
	<T> Long selectShardingCount(Class<T> cls, QueryWrapper<T> queryWrapper,Date startTime,Date endTime);

	/**
	 * 查询每一张表分表后的总数
	 * @param <T>
	 * 
	 * @param tableNamePrefix 分表名称前缀
	 * @param queryWrapper    查询条件
	 * @return
	 */
	<T> List<ShardingEntity> selectShardingGroupTableCount(Class<T> cls, QueryWrapper<T> queryWrapper,Date startTime,Date endTime);

	/**
	 * 分页查询
	 * 
	 * @param tableNamePrefix
	 * @param queryWrapper
	 * @param pageNo
	 * @param pageSize
	 * @param startTime 分表起始
	 * @param endTime 分表结束
	 * @return
	 */
	<T> PagedResponse<T> selectShardingPageList(Class<T> cls, QueryWrapper<T> queryWrapper, Integer pageNo,
			Integer pageSize,Date startTime,Date endTime);

	/**
	 * 新增
	 * 
	 * @param obj
	 * @param time 分表的时间字段
	 */
	void save(Object obj, Date time);

	/**
	 * 更新 主键
	 * 
	 * @param obj
	 * @param time 分表的时间字段
	 */
	void update(Object obj, Date time);

	/**
	 * 删除 主键
	 * 
	 * @param obj
	 * @param time 分表的时间字段
	 */
	void delete(Object obj, Date time);

	/**
	 * 删除 主键
	 * 
	 * @param obj
	 */
	void delete(Object obj);

	/**
	 * 删除或更改
	 * 
	 * @param obj
	 * @param time
	 */
	void saveOrUpdate(Object obj, Date time);

	/**
	 * 根据主键
	 * 
	 * @param <T>
	 * @param cls
	 * @param id
	 * @return
	 */
	<T> T getById(Class<T> cls, Serializable id);
}
