package com.persagy.apm.dmpalarm.service.impl;

import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.persagy.apm.dmpalarm.config.DmpParameterStorage;
import com.persagy.apm.dmpalarm.criteria.CriteriaUtils;
import com.persagy.apm.dmpalarm.web.BaseResponse;
import org.springframework.beans.factory.annotation.Autowired;

public class BaseServiceImpl<M extends BaseMapper<T>, T> extends ServiceImpl<BaseMapper<T>, T> {
    @Autowired
    protected CriteriaUtils criteriaUtils;

    protected class AlarmParam {
        String groupCode;
        String userId;
        String projectId;
        String appId;
    }


    protected AlarmParam prepareParam(BaseResponse<?> resp) {
        AlarmParam param = new AlarmParam();
        param.groupCode = DmpParameterStorage.getGroupCode();
        param.userId = DmpParameterStorage.getUserId();
        param.projectId = DmpParameterStorage.getProjectId();
        param.appId = DmpParameterStorage.getAppId();
        if (param.userId == null || param.userId.isEmpty()) {
            resp.setResult("fail");
            resp.setMessage("userId 必须有值");
            return null;
        }
        if (param.groupCode == null || param.groupCode.isEmpty()) {
            resp.setResult("fail");
            resp.setMessage("groupCode 必须有值");
            return null;
        }
        if (param.projectId == null || param.projectId.isEmpty()) {
            resp.setResult("fail");
            resp.setMessage("projectId 必须有值");
            return null;
        }
        return param;
    }
}
