package com.persagy.apm.dmpalarm.web;

import java.util.LinkedList;
import java.util.List;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.persagy.apm.dmpalarm.model.DmpMessage;

import lombok.Getter;
import lombok.Setter;

/**
 * @author: yaoll
 * @date: 2020-09-04
 * @verison: 1.0
 */
public class BaseResponse<T> {

	public static final String SUCCESS = "success";
	public static final String FAIL = "fail";
	public static final String EXCEPTION = "exception";

	@Getter
	@Setter
	private String result;

	@Getter
	@Setter
	private String message;

	@Getter
	@Setter
	protected T data;

	@JsonIgnore
	@Getter
	private List<DmpMessage> messageList;

	public void setFail(String message) {
		setResult(FAIL);
		setMessage(message);
	}

	public BaseResponse() {
		super();
		this.result = SUCCESS;
	}

	public BaseResponse(String result, String message) {
		super();
		this.result = result;
		this.message = message;
	}

	public boolean success() {
		return SUCCESS.equals(this.result);
	}

	public void add(DmpMessage msg){
		if (messageList == null) {
			messageList = new LinkedList<>();
		}
		messageList.add(msg);
	}

	public void add(List<DmpMessage> msgs){
		if (messageList == null) {
			messageList = new LinkedList<>();
		}
		messageList.addAll(msgs);
	}
}
